package Spot 
{
	import com.wordpress.kahshiu.utils.Vector2d;
	import com.wordpress.kahshiu.utils.Math2;
	import flash.display.Sprite;
	import flash.display3D.textures.Texture;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.geom.ColorTransform;
	import flash.geom.Point;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.utils.Timer;
	/**
	 * ...
	 * @author Shiu
	 */
	[SWF(width='400', height='300')]
	public class Demo1 extends Sprite
	{
		private var center:Point;
		private var a1:Arrow, a2:Arrow;
		private var v1:Vector2d, v2:Vector2d, curr_vec:Vector2d;
		private var feedback:TextField;
		private var t:Timer;
		
		private var item:int, direction:Number;
		private var cmd:Vector.<int>;
		private var coords:Vector.<Number>;
		private var theta_rad:Number, theta_deg:Number;
		
		public function Demo1() 
		{
			feedback = new TextField; addChild(feedback);
			feedback.selectable = false;
			feedback.autoSize = TextFieldAutoSize.LEFT;
			
			a1 = new Arrow; addChild(a1); 
			a2 = new Arrow; addChild(a2); a2.rotation = 90
			
			center = new Point(stage.stageWidth >> 1, stage.stageHeight >> 1)
			a1.x = center.x;  a1.y = center.y; a1.name = "a1";
			a2.x = center.x;  a2.y = center.y; a2.name = "a2";
			
			a1.transform.colorTransform = new ColorTransform(0, 0, 0, 1, 255);
			a2.transform.colorTransform = new ColorTransform(0, 0, 0, 1, 0, 255);
			
			a1.addEventListener(MouseEvent.MOUSE_DOWN, handleMouse);
			a2.addEventListener(MouseEvent.MOUSE_DOWN, handleMouse);
			stage.addEventListener(MouseEvent.MOUSE_UP, handleMouse);
			
			v1 = new Vector2d(1, 0);
			v2 = new Vector2d(0, 1);
			curr_vec = new Vector2d(1, 0);
			
			t = new Timer(50);
		}
		
		private function handleMouse(e:MouseEvent):void 
		{
			if (e.type == "mouseDown") {
				if (e.target.name == "a1") 		item = 1;
				else if (e.target.name == "a2") item = 2;
				t.start()
				t.addEventListener(TimerEvent.TIMER, update);
			}
			else if (e.type == "mouseUp") {
				t.stop();
				t.removeEventListener(TimerEvent.TIMER, update);
			}
		}
		
		private function update(e:TimerEvent):void 
		{
			var curr_angle:Number = Math.atan2(mouseY - center.y, mouseX - center.x);
			curr_vec.angle = curr_angle;
			
			if (item == 1) {
				//update red arrow's rotation visually
				a1.rotation = Math2.degreeOf(curr_angle);
				//measuring the angle from green to red
				v1 = curr_vec.clone();
				direction = v2.crossProduct(v1);
				feedback.text = "You are now moving the red vector, A \n";
				feedback.appendText("Angle measured from green to red: ");
			}
			else if (item == 2) {
				//update green arrow's rotation visually
				a2.rotation = Math2.degreeOf(curr_angle);
				//measuring the angle from red to green
				v2 = curr_vec.clone();
				direction = v1.crossProduct(v2);
				feedback.text = "You are now moving the green vector, B\n";
				feedback.appendText("Angle measured from red to green: ");
			}
			
			theta_rad = Math.acos(v1.dotProduct(v2));	//theta is in radians
			theta_deg = Math2.degreeOf(theta_rad);
			if (direction < 0) {
				feedback.appendText("-" + theta_deg.toPrecision(4) + "\n");
				feedback.appendText("rotation is anti clockwise")
			}
			else {
				feedback.appendText(theta_deg.toPrecision(4) + "\n");
				feedback.appendText("rotation is clockwise")
			}
			drawSector();
		}
		
		private function drawSector():void {
			
			var init_vec:Vector2d
			if (item == 1) init_vec = v2.clone();
			else if (item == 2) init_vec = v1.clone();
			init_vec.scale(40);
			
			cmd = new Vector.<int>;
			coords = new Vector.<Number>;
			
			for (var i:int = 1; i < Math.round(theta_deg); i++) 
			{
				if(i == 1) cmd.push(1);
				else cmd.push(2);
				
				var coordX:Number, coordY:Number;
				if(direction >= 0){
					coordX = init_vec.x * Math.cos(theta_rad) - init_vec.y * Math.sin(theta_rad)
					coordY = init_vec.x * Math.sin(theta_rad) + init_vec.y * Math.cos(theta_rad)
				}
				else {
					coordX = init_vec.x * Math.cos(theta_rad) + init_vec.y * Math.sin(theta_rad)
					coordY = -init_vec.x * Math.sin(theta_rad) + init_vec.y * Math.cos(theta_rad)
				}
				coords.push(center.x + coordX);
				coords.push(center.y + coordY);
				theta_rad -= Math2.radianOf(1);
			}
			
			graphics.clear();
			graphics.lineStyle(1);
			graphics.drawPath(cmd, coords);
		}
		
	}

}