package Spot 
{
	import com.wordpress.kahshiu.Shapes.Circle;
	import com.wordpress.kahshiu.utils.Vector2d;
	import com.wordpress.kahshiu.utils.Math2;
	import flash.display.Sprite;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.geom.Point;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.utils.Timer;
	import flash.ui.Keyboard;
	/**
	 * ...
	 * @author Shiu
	 */
	[SWF(width='400', height='300')]
	public class Demo3 extends Sprite
	{
		private var prev_vec:Vector2d;
		private var curr_vec:Vector2d;
		private var total_angle:Number;
		private const CIRCLE_ANGLE:Number = Math2.radianOf(300);
		private const MIN_DIST:Number = 60;
		private var within_bound:Boolean;
		
		private var marker:Point, c:Circle;
		private var t:Timer, feedback:TextField, mag_box:TextField;
		private var indicator:Sprite;
		
		public function Demo3() 
		{
			c = new Circle(20); addChild(c);
			c.x = stage.stageWidth >> 1; 
			c.y = stage.stageHeight >> 1;
			marker = new Point(c.x, c.y);
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN, handleMouse);
			stage.addEventListener(MouseEvent.MOUSE_UP, handleMouse);
			stage.addEventListener(KeyboardEvent.KEY_DOWN, handleKey);
			t = new Timer(50);
			
			feedback = new TextField; addChild(feedback);
			feedback.autoSize = TextFieldAutoSize.LEFT;
			indicator = new Sprite(); addChild(indicator);
			
			mag_box = new TextField();	addChild(mag_box);
			mag_box.x = -100; mag_box.y = -100;
			mag_box.autoSize = TextFieldAutoSize.LEFT;
		}
		
		private function handleKey(e:KeyboardEvent):void 
		{
			if (e.keyCode == Keyboard.A) 		c.x -= 10;
			else if (e.keyCode == Keyboard.D) 	c.x += 10;
			marker.x = c.x;
			
			if (e.keyCode == Keyboard.S) 		c.y += 10
			else if (e.keyCode == Keyboard.W) 	c.y -= 10;
			marker.y = c.y
		}
		
		private function handleMouse(e:MouseEvent):void 
		{
			if (e.type == "mouseDown") {
				with (indicator) {
					graphics.clear();
					graphics.lineStyle(1);
					graphics.moveTo(marker.x, marker.y);
					graphics.lineTo(mouseX, mouseY);
				}
				
				curr_vec = new Vector2d(mouseX - marker.x, mouseY - marker.y);
				within_bound = true;
				total_angle = 0;
				t.addEventListener(TimerEvent.TIMER, update)
				t.start();
			}
			else if (e.type == "mouseUp") {
				t.stop();
				t.removeEventListener(TimerEvent.TIMER, update);
				update_feedback();
				
				mag_box.x = -100; mag_box.y = -100;
			}
		}
		
		private function update(e:TimerEvent):void 
		{
			graphics.clear();
			graphics.lineStyle(1)
			graphics.moveTo(marker.x, marker.y);
			graphics.lineTo(mouseX, mouseY);
			
			prev_vec = curr_vec.clone();
			curr_vec = new Vector2d(mouseX - marker.x, mouseY - marker.y);
			
			if (curr_vec.magnitude > MIN_DIST) within_bound = false;
			
			//value of calculation sometimes exceed 1 need to manually handle the precission
			var constants_value:Number = Math.min(1, 
										prev_vec.dotProduct(curr_vec) / (prev_vec.magnitude * curr_vec.magnitude)
										);
			var delta_angle:Number = Math.acos(constants_value)	//angle made
			var direction:Number = prev_vec.crossProduct(curr_vec) > 0? 1: -1;	//checking the direction of rotation
			total_angle += direction * delta_angle;	//add to the cumulative angle made during the interaction
			
			mag_box.text = "Distance from marker: " + curr_vec.magnitude.toPrecision(4);
			mag_box.x = mouseX + 10;
			mag_box.y = mouseY + 10;
			feedback.text = "Do not go beyond "+MIN_DIST
		}
		
		private function update_feedback():void {
			feedback.text = "You have made " + Math2.degreeOf(total_angle).toPrecision(4)+".\n";
			if (Math.abs(total_angle) > CIRCLE_ANGLE) {
				feedback.appendText("Marker circled. Cos its more than " + Math2.degreeOf(CIRCLE_ANGLE).toPrecision(4));
			}
			else {
				feedback.appendText("Not a complete circle. Cos its less than " + Math2.degreeOf(CIRCLE_ANGLE).toPrecision(4))
			}
			
			if (within_bound) {
				feedback.appendText("\nGesture is made within bound")
			}
			else {
				feedback.appendText("\nAre you making a random guess?")
			}
		}
	}

}