package Spot 
{
	import com.wordpress.kahshiu.Shapes.Circle;
	import com.wordpress.kahshiu.utils.Math2;
	import com.wordpress.kahshiu.utils.Vector2d;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.geom.Point;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.utils.Timer;
	/**
	 * ...
	 * @author Shiu
	 */
	[SWF(width='400', height='300')]
	public class Demo4 extends Sprite
	{
		private var markers:Vector.<Point>;
		private var circles:Vector.<Circle>;
		
		private var proximity:Vector.<Boolean>;
		private var angles:Vector.<Number>;
		
		private var previous_vecs:Vector.<Vector2d>;
		private var current_vecs:Vector.<Vector2d>;
		
		private var t:Timer;
		private const MIN_DIST:Number = 40;
		private const MIN_ANGLE:Number = Math2.radianOf(300)
		
		private var box:TextField;
		private var condition1:Boolean, condition2:Boolean;
		public function Demo4() 
		{
			circles = new Vector.<Circle>;
			var c1:Circle = new Circle();	addChild(c1);
			var c2:Circle = new Circle();	addChild(c2);
			var c3:Circle = new Circle();	addChild(c3);
			
			c1.x = 150; c1.y = 50;
			c2.x = 250; c2.y = 150;
			c3.x = 150; c3.y = 200;
			
			circles.push(c1);
			circles.push(c2);
			circles.push(c3);
			
			markers = new Vector.<Point>;
			proximity = new Vector.<Boolean>;
			angles = new Vector.<Number>;
			
			previous_vecs = new Vector.<Vector2d>;
			current_vecs = new Vector.<Vector2d>;
			
			for (var i:int = 0; i < 3; i++) {
				var m:Point = new Point(circles[i].x, circles[i].y)
				markers.push(m);
				proximity.push(false);
				angles.push(0);
				
				previous_vecs.push(new Vector2d(0, 0));
				current_vecs.push(new Vector2d(0, 0));
			}
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN, handleMouse);
			stage.addEventListener(MouseEvent.MOUSE_UP, handleMouse);
			t = new Timer(50);
			
			box = new TextField(); addChild(box);
			box.selectable = false;
			box.autoSize = TextFieldAutoSize.LEFT;
		}
		
		private function handleMouse(e:MouseEvent):void 
		{
			if (e.type == "mouseDown") {
				t.addEventListener(TimerEvent.TIMER, update);
				t.start();
				update_curr_vecs();
			}
			else if (e.type == "mouseUp") {
				t.stop();
				t.removeEventListener(TimerEvent.TIMER, update);
				
				//check if conditions were met
				condition1 = true	//all angles are meeting MIN_ANGLE
				condition2 = true	//all proximities are meeting MIN_DIST
				
				for (var i:int = 0; i < markers.length; i++) {
					if (Math.abs(angles[i])< MIN_ANGLE) {
						condition1 = false;
						break;
					}
					if (proximity[i] == false) {
						condition2 = false;
						break
					}
				}
				
				if (condition1 && condition2) {
					box.text="Attempt to circle the item is successful"
				}
				else {
					box.text="Failure"
				}
				
				reset_vecs();
				reset_values();
			}
		}
		
		private function update(e:TimerEvent):void 
		{
			update_prev_vecs();
			update_curr_vecs();
			update_values();
		}
		
		private function calc_proximity(curr:Vector2d):Boolean {
			return curr.magnitude < MIN_DIST? true:false;
		}
		
		private function calc_angle(prev:Vector2d, curr:Vector2d):Number {
			var prev_unit:Vector2d = prev.unitVector;
			var curr_unit:Vector2d = curr.unitVector;
			
			var value:Number = Math.min(1, prev_unit.dotProduct(curr_unit));
			var direction:Number = prev_unit.crossProduct(curr_unit) < 0? -1:1;
			
			return direction * Math.acos(value);
		}
		
		private function update_prev_vecs():void {
			for (var i:int = 0; i < markers.length; i++) {
				previous_vecs[i] = current_vecs[i].clone();
			}
		}
		
		private function update_curr_vecs():void {
			for (var i:int = 0; i < markers.length; i++) {
				current_vecs[i].x = mouseX - markers[i].x
				current_vecs[i].y = mouseY - markers[i].y
			}
		}
		
		private function reset_vecs():void {
			for (var i:int = 0; i < markers.length; i++) {
				previous_vecs[i].x = 0;
				previous_vecs[i].y = 0;
				current_vecs[i].x = 0;
				current_vecs[i].y = 0;
			}
		}
		
		private function update_markers():void {
			for (var i:int = 0; i < markers.length; i++) {
				markers[i].x = circles[i].x;
				markers[i].y = circles[i].y;
			}
		}
		
		private function update_values():void {
			for (var i:int = 0; i < markers.length; i++) {
				angles[i] += calc_angle(previous_vecs[i], current_vecs[i]);
				if (calc_proximity(current_vecs[i])) proximity[i] = true;
			}
		}
		
		private function reset_values():void {
			for (var i:int = 0; i < markers.length; i++) {
				proximity[i] = false;
				angles[i] = 0;
			}
		}
	}

}