package Spot 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BlendMode;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	/**
	 * ...
	 * @author Shiu
	 */
	[SWF(width='500', height='300')]
	public class Drawing2 extends Sprite
	{
		private var cmd:Vector.<int>;
		private var coords:Vector.<Number>;
		private var _thickness:Number = 2, _col:Number = 0, _alpha:Number = 1;
		
		private var bitmap:Bitmap;
		private var data:BitmapData;
		
		public function Drawing2() 
		{
			//assign event handlerst to mouse up and mouse down
			stage.addEventListener(MouseEvent.MOUSE_DOWN, mouseHandler);
			stage.addEventListener(MouseEvent.MOUSE_UP, mouseHandler);
			
			//prepare the bitmap and data to draw into bitmap
			bitmap = new Bitmap(); addChild(bitmap);
		}
		
		/**
		 * Mouse event handler
		 * @param	e	mouse event
		 */
		private function mouseHandler(e:MouseEvent):void 
		{
			if (e.type == "mouseDown") {
				//randomise the line properties
				_thickness = Math.random() * 5;
				_col = Math.random() * 0xffffff;
				_alpha = Math.random() * 0.5 + 0.5
				
				//initiate the variables
				cmd = new Vector.<int>;
				coords = new Vector.<Number>;
				
				//first registration of line beginning
				cmd[0] = 1;
				coords[0] = mouseX;
				coords[1] = mouseY;
				
				//start the drawing when mouse move
				stage.addEventListener(MouseEvent.MOUSE_MOVE, mouseHandler);
			}
			else if (e.type == "mouseUp") {
				//remove the mouse move handler once mouse button is released
				stage.removeEventListener(MouseEvent.MOUSE_MOVE, mouseHandler);
				
				//storing drawing into a bitmap
				storeImage();
			}
			else if (e.type == "mouseMove") {
				//pushing into the mouse move the
				cmd.push(2);			//draw command
				coords.push(mouseX);	//coordinates to draw line to
				coords.push(mouseY);
				redraw();				//execute the drawing command
			}
		}
		/**
		 * Method to draw the line(s) as defined by mouse movement
		 */
		private function redraw():void {
			graphics.clear();
			graphics.lineStyle(_thickness, _col, _alpha);
			graphics.drawPath(cmd, coords);
		}
		
		private function storeImage ():void {
			data = new BitmapData(stage.stageWidth, stage.stageHeight, true, 0xffffff);
			data.draw(this, new Matrix(), null, BlendMode.ADD);
			bitmap.bitmapData = data;
		}
	}

}