package Spot 
{
	import com.wordpress.kahshiu.Shapes.Circle;
	import com.wordpress.kahshiu.SpotGame.CircleGroup;
	import com.wordpress.kahshiu.SpotGame.CirclePoint;
	import com.wordpress.kahshiu.SpotGame.GroupMan;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BlendMode;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.utils.Timer;
	/**
	 * ...
	 * @author Shiu
	 */
	[SWF(width='500', height='450')]
	public class Sample2 extends Sprite
	{
		//game data
		private var gRunning:Boolean = false;
		private var gTimer:Timer, feedback:TextField;
		private var groupsManager:GroupMan;
		private var spotted_differences:Vector.<int>;
		
		//game assets
		[Embed(source = "../../lib/img/Pic1.jpg")] private var Original:Class;
		[Embed(source = "../../lib/img/Pic2.jpg")] private var Modified:Class;
		private var markers:Vector.<Point>;
		
		//game canvas
		private var bmp:Bitmap;
		private var canvas:Sprite;
		private var cmd:Vector.<int>;
		private var coord:Vector.<Number>;
		private var hours:Number,minutes:Number,seconds:Number;
		
		public function Sample2() 
		{
			//placing the images onto screen
			var left:Bitmap = new Original as Bitmap;	addChild(left); 
			var right:Bitmap = new Modified as Bitmap;	addChild(right);
			right.x += left.width;
			
			feedback = new TextField();	addChild(feedback);
			feedback.y = stage.stageHeight - 50;
			feedback.autoSize = TextFieldAutoSize.LEFT;
			feedback.text = "To start the game, click anywhere on screen"
			
			//enable user interaction
			initAssets();
			stage.addEventListener(MouseEvent.MOUSE_DOWN, gameStart);
		}
		
		private function initAssets():void {
			var cp1:CirclePoint = new CirclePoint(209,228, 20); //shoelace
			var cp2:CirclePoint = new CirclePoint(55, 229, 30); //black detail on white shoe
			var cp3:CirclePoint = new CirclePoint(62, 312, 20);	//for the handles on left
			var cp4:CirclePoint = new CirclePoint(60, 355, 20); 
			var cp5:CirclePoint = new CirclePoint(100, 320, 20); //for the handles on right
			var cp6:CirclePoint = new CirclePoint(100, 355, 20);
			var cp7:CirclePoint = new CirclePoint(239, 158, 30);	//shoe on border
			var cp8:CirclePoint = new CirclePoint(102, 261, 25);	//red highlight patch
			var cp9:CirclePoint = new CirclePoint(138, 254, 25);
			
			var g1:CircleGroup = new CircleGroup(); g1.registerGroup(cp1);
			var g2:CircleGroup = new CircleGroup(); g2.registerGroup(cp2);
			var g3:CircleGroup = new CircleGroup(); g3.registerGroup(cp3); g3.registerGroup(cp4);
			var g4:CircleGroup = new CircleGroup(); g4.registerGroup(cp5); g4.registerGroup(cp6);
			var g5:CircleGroup = new CircleGroup(); g5.registerGroup(cp7);
			var g6:CircleGroup = new CircleGroup(); g6.registerGroup(cp8); g6.registerGroup(cp9);
			
			groupsManager = new GroupMan(); addChild(groupsManager);
			groupsManager.registerGroups(g1);
			groupsManager.registerGroups(g2);
			groupsManager.registerGroups(g3);
			groupsManager.registerGroups(g4);
			groupsManager.registerGroups(g5);
			groupsManager.registerGroups(g6);
			//groupsManager.showCircles();
			
			//game canvas
			bmp = new Bitmap;  addChild(bmp); bmp.name = "bmp"
			bmp.bitmapData = new BitmapData(stage.stageWidth, stage.stageHeight, true, 0x00000000);
			
			canvas = new Sprite; addChild(canvas);
		}
		
		private function resetAssets():void 
		{
			var bmpd:Bitmap = getChildAt(4) as Bitmap;
			bmp.bitmapData = new BitmapData(stage.stageWidth, stage.stageHeight, true, 0x00000000);
			
			spotted_differences = new Vector.<int>;
			feedback.text = "";
		}
		
		private function gameStart(e:MouseEvent):void 
		{
			if (!gRunning) {
				stage.removeEventListener(MouseEvent.MOUSE_DOWN, gameStart);
				gRunning = true;
				resetAssets();
				
				//run game
				stage.addEventListener(MouseEvent.MOUSE_DOWN, gameRun);
				stage.addEventListener(MouseEvent.MOUSE_UP, gameRun);
				
				gTimer = new Timer(50); gTimer.start();
				gTimer.addEventListener(TimerEvent.TIMER, refresh);
			}
		}
		
		private function gameRun(e:MouseEvent):void 
		{
			if (e.type == "mouseDown") {
				stage.addEventListener(MouseEvent.MOUSE_MOVE, gameRun);
				groupsManager.start(mouseX, mouseY);
				
				//drawing start
				cmd = new Vector.<int>;
				coord = new Vector.<Number>;
				cmd[0] = 1;
				coord.push(mouseX, mouseY);
			}
			
			else if (e.type == "mouseMove") {
				groupsManager.update(mouseX, mouseY);
				
				//drawing
				cmd.push(2);
				coord.push(mouseX, mouseY);
				
				with (canvas) {
					graphics.clear();
					graphics.lineStyle(2, 0xff0000);
					graphics.drawPath(cmd, coord);
				}
			}
			
			else if (e.type == "mouseUp") {
				stage.removeEventListener(MouseEvent.MOUSE_MOVE, gameRun);
				
				//storing drawing
				if (validCircle()) {
					storeCanvas();
					updateSpottedList();
					
					if (spotted_differences.length == groupsManager.groups.length) {
						//switch backt to game state start
						feedback.text = hours + "h: " + minutes + "m: " + seconds + "s\n";
						feedback.appendText("You have spotted " + spotted_differences.length + " of " + groupsManager.groups.length+". \n")
						feedback.appendText("You have won! Click again to replay");
						
						gTimer.reset();
						gTimer.removeEventListener(TimerEvent.TIMER, refresh);
						stage.removeEventListener(MouseEvent.MOUSE_DOWN, gameRun);
						stage.removeEventListener(MouseEvent.MOUSE_UP, gameRun);
						
						gRunning = false;
						stage.addEventListener(MouseEvent.MOUSE_DOWN, gameStart);
					}
				}
				canvas.graphics.clear();
				groupsManager.reset();
			}
		}
		
		//valid and non repeating result 
		private function validCircle():Boolean {
			var result:Boolean = true;
			
			var current_result:Vector.<int> = groupsManager.circled();
			if (current_result.length == 0) {		//nothing is circled
				result = false;
			}
			else if (current_result.length == 1) {	//one difference is circled
				//validate for non-repetiting item
				for (var i:int = 0; i < spotted_differences.length; i++) {
					if (current_result[0] == spotted_differences[i]) {
						result = false;
					}
				}
			}
			else if (current_result.length == 2) {	//two difference is circled--> remember at the handle? chances are players will circle one or two handles at once.
				//validate for non-repetiting item
				if (current_result[0] != 2 && current_result[1] != 3) {
					result = false;
				}
			}
			else {	//more than two differences circled--> players are trying to draw a circle around everhthing
				result = false;
			}
			
			return result;
		}
		
		private function updateSpottedList():void {
			var current_spotted:Vector.<int> = groupsManager.circled()
			
			//store only unique numbers into spotted array
			//remember, you can also choose a both left and right handles as well
			for (var i:int = 0; i < current_spotted.length; i++) {
				var shared:Boolean = false;
				for (var j:int = 0; j < spotted_differences.length; j++) {
					if (current_spotted[i] == spotted_differences[j]) {
						shared = true;
						break;
					}
				}
				if (!shared) spotted_differences.push(current_spotted[i]);
			}
			trace(current_spotted)
			trace(spotted_differences)
		}
		
		private function storeCanvas():void {
			var current_drawing:BitmapData = bmp.bitmapData;
			current_drawing.draw(canvas, new Matrix, null, BlendMode.ADD);
			bmp.bitmapData = current_drawing
		}
		
		private function refresh(e:TimerEvent):void 
		{
			seconds = Math.round(gTimer.currentCount * 0.05);
			minutes = Math.round(seconds / 60);
			hours = Math.round(minutes / 60);
			
			feedback.text = hours + "h: " + minutes + "m: " + seconds + "s\n";
			feedback.appendText("You have spotted " + spotted_differences.length + " of " + groupsManager.groups.length+". \n")
		}
	}

}