package com.wordpress.kahshiu.SpotGame 
{
	import com.wordpress.kahshiu.Shapes.Circle;
	import com.wordpress.kahshiu.utils.Vector2d;
	import flash.geom.Point;
	/**
	 * ...
	 * @author Shiu
	 */
	public class CircleGroup
	{
		public var group:Vector.<CirclePoint>;
		
		public function CircleGroup() {
			group = new Vector.<CirclePoint>;
		}
		
		public function registerGroup(...points):void {
			for each (var item:CirclePoint in points) {
				group.push(item)
			}
		}
		
		public function getLocation(index:int):Point {
			return new Point(group[index].x, group[index].y);
		}
		
		public function start(mouse_X:Number, mouse_Y:Number):void {	
			for (var i:int = 0; i < group.length; i++) {
				var member:CirclePoint = group[i]
				member.curr_vec.x = mouse_X - member.x;
				member.curr_vec.y = mouse_Y - member.y;
			}
		}
		
		public function updateWith(mouse_X:Number, mouse_Y:Number):void {
			for (var i:int = 0; i < group.length; i++) {
				var member:CirclePoint = group[i];
				member.prev_vec = member.curr_vec.clone();
				member.curr_vec.x = mouse_X - member.x;
				member.curr_vec.y = mouse_Y - member.y;
				
				member.elapsed_angle += calculateAngle(member.prev_vec, member.curr_vec);
				if(!member.crossed) member.crossed = evaluateProximity(i);
			}
		}
		
		public function reset():void {
			for (var i:int = 0; i < group.length; i++) {
				group[i].elapsed_angle = 0;
				group[i].crossed = false;
				group[i].prev_vec.x = 0;
				group[i].prev_vec.y = 0;
			}
		}
		
		private function evaluateProximity(index:int):Boolean {
			return group[index].curr_vec.magnitude < group[index].min_radius
		}
		
		private function calculateAngle(from:Vector2d, to:Vector2d):Number {
			var dot_val:Number = from.dotProduct(to);
			dot_val = dot_val / (from.magnitude * to.magnitude);
			dot_val = Math.max( -1, Math.min(1, dot_val));
			
			var cross_val:Number = from.crossProduct(to);
			cross_val > 0? cross_val = 1:cross_val = -1;
			
			return cross_val * Math.acos(dot_val);
		}
		
		public function validity():Boolean {
			var result:Boolean = true;
			for (var i:int = 0; i < group.length; i++) {
				if (
				group[i].crossed == false || 
				Math.abs(group[i].elapsed_angle) < Math.PI/180*300) {
					result = false;
					break;
				}
			}
			return result;
		}
	}

}